// Direct3DRMDevice.cpp: Implementierung der Klasse CDirect3DRMDevice.
//
//////////////////////////////////////////////////////////////////////

#include "Direct3DRM.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDirect3DRMDevice::CDirect3DRMDevice()
{
	// ... und jetzt Objekte lschen
	lpD3DRMDevice = NULL;
	pDirect3DRM = NULL;
}

CDirect3DRMDevice::CDirect3DRMDevice(CDirect3DRM* pD3DRM)
{
	// ... und jetzt Objekte setzen
	lpD3DRMDevice = NULL;
	pDirect3DRM = pD3DRM;
}

CDirect3DRMDevice::CDirect3DRMDevice(CDirect3DRM* pD3DRM,
									 DXDLL_LPDIRECT3DRMDEVICE lpDev)
{
	// ... und jetzt Objekte setzen
	lpD3DRMDevice = lpDev;
	pDirect3DRM = pD3DRM;
}

CDirect3DRMDevice::~CDirect3DRMDevice()
{
	// ... am Ende Device wieder lschen
	DestroyDirect3DDevice();
}

void CDirect3DRMDevice::DestroyDirect3DDevice()
{
	// existiert berhaupt eins?
	if (lpD3DRMDevice)
	{
		// ... dann lschen
		lpD3DRMDevice->Release();
		lpD3DRMDevice = NULL;
	}
}

int CDirect3DRMDevice::Update()
{
	// updatet Frame
	// aus Geschwindigkeitsgrnden kein Sicherheitscheck!
	return lpD3DRMDevice->Update();
}

int CDirect3DRMDevice::GetWidth()
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
		// ... dann Breite zurckliefern
		return lpD3DRMDevice->GetWidth();

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::GetHeight()
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
		// ... dann Breite zurckliefern
		return lpD3DRMDevice->GetHeight();

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}


int CDirect3DRMDevice::SetBufferCount(DWORD dwBufferSize)
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
		// ... dann Anzahl Buffer neu setzen
		return lpD3DRMDevice->SetBufferCount(dwBufferSize);

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::GetBufferCount()
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
		// ... dann Anzahl Buffer zurckliefern
		return lpD3DRMDevice->GetBufferCount();

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::GetColorModel(D3DCOLORMODEL* lpD3DModel)
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
	{
		// ... dann Colormodell ermitteln
		*lpD3DModel = lpD3DRMDevice->GetColorModel();
		// kein Fehler!
		return DXDLL_OK;
	}

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::SetDither(BOOL bDither)
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
		// ... dann Ditheringmode neu setzen
		return lpD3DRMDevice->SetDither(bDither);

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::GetDither(BOOL* bDither)
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
	{
		// ... dann Colormodell ermitteln
		*bDither = lpD3DRMDevice->GetDither();
		// kein Fehler!
		return DXDLL_OK;
	}

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::GetTrianglesDrawn()
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
		// ... dann Anzahl zurckliefern
		return lpD3DRMDevice->GetTrianglesDrawn();

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::GetWireframeOptions()
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
		// ... dann Optionen zurckliefern
		return lpD3DRMDevice->GetWireframeOptions();

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::SetQuality(D3DRMRENDERQUALITY d3dQuality)
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
		// ... dann Qualitt neu setzen
		return lpD3DRMDevice->SetQuality(d3dQuality);

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::GetQuality(D3DRMRENDERQUALITY* d3dQuality)
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
	{
		// ... dann Renderqualitt ermitteln
		*d3dQuality = lpD3DRMDevice->GetQuality();
		// kein Fehler!
		return DXDLL_OK;
	}

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::SetShades(DWORD dwShades)
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
		// ... dann Schattenanzahl neu setzen
		return lpD3DRMDevice->SetShades(dwShades);

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::GetShades(DWORD* dwShades)
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
	{
		// ... dann Schattenanzahl ermitteln
		*dwShades = lpD3DRMDevice->GetShades();
		// kein Fehler!
		return DXDLL_OK;
	}

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::SetTextureQuality(D3DRMTEXTUREQUALITY d3dTexQuality)
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
		// ... dann Texturequalitt neu setzen
		return lpD3DRMDevice->SetTextureQuality(d3dTexQuality);

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::GetTextureQuality(D3DRMTEXTUREQUALITY* d3dTexQuality)
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
	{
		// ... dann Rendermode ermitteln
		*d3dTexQuality = lpD3DRMDevice->GetTextureQuality();
		// kein Fehler!
		return DXDLL_OK;
	}

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::SetRenderMode(DWORD dwFlags)
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
		// ... dann Rendermode neu setzen
		return lpD3DRMDevice->SetRenderMode(dwFlags);

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::GetRenderMode(DWORD* dwFlags)
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
	{
		// ... dann Rendermode ermitteln
		*dwFlags = lpD3DRMDevice->GetRenderMode();
		// kein Fehler!
		return DXDLL_OK;
	}

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::AddUpdateCallback(DXDLL_D3DRMUPDATECALLBACK 
										 d3drmUpdateProc, LPVOID arg)
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
		// ... dann hinzufgen
		return lpD3DRMDevice->AddUpdateCallback(d3drmUpdateProc, arg);

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMDevice::DeleteUpdateCallback(DXDLL_D3DRMUPDATECALLBACK 
											d3drmUpdateProc, LPVOID arg)
{
	// existiert Device berhaupt?
	if (lpD3DRMDevice)
		// ... dann lschen
		return lpD3DRMDevice->DeleteUpdateCallback(d3drmUpdateProc, arg);

	// ... ansonsten eben interner Error
	return DXDLL_INTERNALERROR;
}

