// Direct3DRMFace.cpp: Implementierung der Klasse CDirect3DRMFace.
//
//////////////////////////////////////////////////////////////////////

#include "Direct3DRMObjects.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDirect3DRMFace::CDirect3DRMFace()
{
	// alles resetten
	lpD3DRMFace = NULL;
	pDirect3DRMMaterial = NULL;
	pDirect3DRMTexture = NULL;
}

CDirect3DRMFace::CDirect3DRMFace(DXDLL_LPDIRECT3DRMFACE lpFace)
{
	// alles resetten
	pDirect3DRMMaterial = NULL;
	pDirect3DRMTexture = NULL;
	// Werte bernehmen
	lpD3DRMFace = lpFace;
}

CDirect3DRMFace::~CDirect3DRMFace()
{
	// bevor wir alles lschen noch das hier machen
	DestroyDirect3DFace();
}

void CDirect3DRMFace::DestroyDirect3DFace()
{
	// existiert ein Face?
	if (lpD3DRMFace)
	{
		// ... dann lschen
		lpD3DRMFace->Release();
		lpD3DRMFace = NULL;
	}
}

int CDirect3DRMFace::SetColor(D3DCOLOR d3dcol)
{
	// existiert Objekt eigentlich?
	if (lpD3DRMFace)
		// ... dann Farbe setzen
		return lpD3DRMFace->SetColor(d3dcol);

	// ... ansonsten nur Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFace::SetColorRGB(D3DVALUE d3dRed, D3DVALUE d3dGreen,
								 D3DVALUE d3dBlue)
{
	// existiert Objekt eigentlich?
	if (lpD3DRMFace)
		// ... dann Farbe setzen
		return lpD3DRMFace->SetColorRGB(d3dRed, d3dGreen, d3dBlue);

	// ... ansonsten nur Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFace::GetColor(D3DCOLOR* d3dcol)
{
	// existiert Objekt eigentlich?
	if (lpD3DRMFace)
	{
		// Farbe holen
		*d3dcol = lpD3DRMFace->GetColor();
		// und zurck
		return DXDLL_OK;
	}

	// ... ansonsten eben Fehler
	return DXDLL_INTERNALERROR;
}

CDirect3DRMMaterial* CDirect3DRMFace::GetMaterial()
{
	// und das Material zurckliefern
	return pDirect3DRMMaterial;
}

int CDirect3DRMFace::SetMaterial(CDirect3DRMMaterial* pMaterial)
{
	HRESULT hres = DXDLL_INTERNALERROR;

	// existiert ein Face?
	if (lpD3DRMFace)
	{
		// ist neues Material ungleich NULL (-> also gltig)?
		if (pMaterial)
			// ... dann Material setzen
			hres = lpD3DRMFace->SetMaterial(pMaterial->lpD3DRMMaterial);
		else
			// ... und Material lschen
			hres = lpD3DRMFace->SetMaterial(NULL);

		// wurde alles ok ausgefhrt?
		if (SUCCEEDED(hres))
			// ... dann neuen Pointer speichern
			pDirect3DRMMaterial = NULL;
	}

	// und das Material zurckliefern
	return hres;
}

CDirect3DRMTexture* CDirect3DRMFace::GetTexture()
{
	// und das Material zurckliefern
	return pDirect3DRMTexture;
}

int CDirect3DRMFace::SetTexture(CDirect3DRMTexture* pTexture)
{
	HRESULT hres = DXDLL_INTERNALERROR;

	// existiert ein Face?
	if (lpD3DRMFace)
	{
		// ist neues Material ungleich NULL (-> also gltig)?
		if (pTexture)
			// ... dann Material setzen
			hres = lpD3DRMFace->SetTexture(pTexture->lpD3DRMTexture);
		else
			// ... und Material lschen
			hres = lpD3DRMFace->SetTexture(NULL);

		// wurde alles ok ausgefhrt?
		if (SUCCEEDED(hres))
			// ... dann neuen Pointer speichern
			pDirect3DRMTexture = NULL;
	}

	// und das Material zurckliefern
	return hres;
}

int CDirect3DRMFace::SetTextureCoordinates(DWORD vertex, D3DVALUE u, 
										   D3DVALUE v)
{
	// existiert ein Face?
	if (lpD3DRMFace)
		// ... und jetzt setzen
		return lpD3DRMFace->SetTextureCoordinates(vertex, u, v);

	// ... ansonsten immer Fehler;
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFace::GetTextureCoordinates(DWORD index, D3DVALUE* lpU,
										   D3DVALUE* lpV)
{
	// existiert ein Face?
	if (lpD3DRMFace)
		// ... und jetzt holen
		return lpD3DRMFace->GetTextureCoordinates(index, lpU, lpV);

	// ... ansonsten immer Fehler;
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFace::GetTextureCoordinateIndex(DWORD which, int* iMesh)
{
	// existiert ein Face?
	if (lpD3DRMFace)
	{
		// ... und jetzt holen
		*iMesh = lpD3DRMFace->GetTextureCoordinateIndex(which);
		// ... und kein Fehler bei Ausfhrung
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler;
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFace::SetTextureTopology(BOOL cylU, BOOL cylV)
{
	// existiert ein Face?
	if (lpD3DRMFace)
		// ... und jetzt setzen
		return lpD3DRMFace->SetTextureTopology(cylU, cylV);

	// ... ansonsten immer Fehler;
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFace::GetTextureTopology(BOOL* lpU, BOOL* lpV)
{
	// existiert ein Face?
	if (lpD3DRMFace)
		// ... und jetzt holen
		return lpD3DRMFace->GetTextureTopology(lpU, lpV);

	// ... ansonsten immer Fehler;
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFace::AddVertex(D3DVALUE d3dx, D3DVALUE d3dy,
							   D3DVALUE d3dz)
{
	// existiert ein Face?
	if (lpD3DRMFace)
		// ... und jetzt holen
		return lpD3DRMFace->AddVertex(d3dx, d3dy, d3dz);

	// ... ansonsten immer Fehler;
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFace::AddVertexAndNormalIndexed(DWORD vertex, DWORD normal)
{
	// existiert ein Face?
	if (lpD3DRMFace)
		// ... und jetzt holen
		return lpD3DRMFace->AddVertexAndNormalIndexed(vertex, normal);

	// ... ansonsten immer Fehler;
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFace::GetNormal(D3DVECTOR* lpNormal)
{
	// existiert ein Face?
	if (lpD3DRMFace)
		// ... und jetzt holen
		return lpD3DRMFace->GetNormal(lpNormal);

	// ... ansonsten immer Fehler;
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFace::GetVertex(DWORD index, D3DVECTOR* lpPosition,
							   D3DVECTOR* lpNormal)
{
	// existiert ein Face?
	if (lpD3DRMFace)
		// ... und jetzt holen
		return lpD3DRMFace->GetVertex(index, lpPosition, lpNormal);

	// ... ansonsten immer Fehler;
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFace::GetVertexCount()
{
	// existiert ein Face?
	if (lpD3DRMFace)
		// ... und jetzt holen
		return lpD3DRMFace->GetVertexCount();

	// ... ansonsten immer Fehler;
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFace::GetVertexIndex(DWORD which)
{
	// existiert ein Face?
	if (lpD3DRMFace)
		// ... und jetzt holen
		return lpD3DRMFace->GetVertexIndex(which);

	// ... ansonsten immer Fehler;
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFace::GetVertices(DWORD *lpdwVertexCount,
								 D3DVECTOR *lpPosition, D3DVECTOR *lpNormal)
{
	// existiert ein Face?
	if (lpD3DRMFace)
		// ... und jetzt holen
		return lpD3DRMFace->GetVertices(lpdwVertexCount, lpPosition,
			lpNormal);

	// ... ansonsten immer Fehler;
	return DXDLL_INTERNALERROR;
}

LPDIRECT3DRMOBJECT CDirect3DRMFace::GetObject()
{
	// und zurckgeben
	return (LPDIRECT3DRMOBJECT)lpD3DRMFace;
}


