// Direct3DRMFrame.cpp: Implementierung der Klasse CDirect3DRMFrame.
//
//////////////////////////////////////////////////////////////////////

#include "Direct3DRM.h"
#include "Direct3DRMObjects.h"
#include "DirectDraw.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDirect3DRMFrame::CDirect3DRMFrame()
{
	// erstmal alles resetten
	lpD3DRMFrame = NULL;
	pDirect3DRM = NULL;
}

CDirect3DRMFrame::CDirect3DRMFrame(CDirect3DRM* pD3DRM)
{
	// erstmal alles resetten
	lpD3DRMFrame = NULL;
	// ... und hier alles bertragen
	pDirect3DRM = pD3DRM;
}

CDirect3DRMFrame::CDirect3DRMFrame(CDirect3DRM* pD3DRM, 
								   DXDLL_LPDIRECT3DRMFRAME lpFrame)
{
	// ... und hier alles bertragen
	lpD3DRMFrame = lpFrame;
	pDirect3DRM = pD3DRM;
}

CDirect3DRMFrame::~CDirect3DRMFrame()
{
	// ... noch alles restliche zerstren
	DestroyDirect3DRMFrame();
}

void CDirect3DRMFrame::DestroyDirect3DRMFrame()
{
	// existiert berhaupt ein Frame?
	if (lpD3DRMFrame)
	{
		// ... wenn ja, dann lschen
		lpD3DRMFrame->Release();
		lpD3DRMFrame = NULL;
	}
}

int CDirect3DRMFrame::Move(D3DVALUE d3dval)
{
	// mit dieser Routine bewegt alle untergeordneten Frames
	// aus Geschwindigkeitsgrnden erfolgt kein Sicherheitstest!
	return lpD3DRMFrame->Move(d3dval);
}

int CDirect3DRMFrame::AddVisual(LPDIRECT3DRMVISUAL lpD3DRMVisual)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann hinzufgen (... oder es versuchen!)
		return lpD3DRMFrame->AddVisual(lpD3DRMVisual);

	// ... ansonsten einen Fehler auslsen
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetAxes(D3DVALUE dx, D3DVALUE dy, D3DVALUE dz,
							  D3DVALUE ux, D3DVALUE uy, D3DVALUE uz)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetAxes(dx, dy, dz, ux, uy, uz);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetAxes(D3DVECTOR* dir, D3DVECTOR* up)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->GetAxes(dir, up);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetInheritAxes(BOOL inherit_from_parent)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetInheritAxes(inherit_from_parent);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetInheritAxes(BOOL* bInherit)
{
	// existiert Frame?
	if (lpD3DRMFrame)
	{
		// ... dann ausfhren
		*bInherit = lpD3DRMFrame->GetInheritAxes();
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetSceneBackground(D3DCOLOR rcColor)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetSceneBackground(rcColor);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetSceneBackground(D3DCOLOR* d3dColor)
{
	// existiert Frame?
	if (lpD3DRMFrame)
	{
		// ... dann ausfhren
		*d3dColor = lpD3DRMFrame->GetSceneBackground();
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetSceneBackgroundDepth(CDirectDrawSurface* pImage)
{
	// existiert Frame und der Rest?
	if (lpD3DRMFrame && pImage && pImage->lpSurface)
		// ... dann ausfhren
		return lpD3DRMFrame->SetSceneBackgroundDepth(
			(LPDIRECTDRAWSURFACE)pImage->lpSurface);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetSceneBackgroundDepth(LPDIRECTDRAWSURFACE lpDDSurface)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->GetSceneBackgroundDepth(&lpDDSurface);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetSceneBackgroundImage(CDirect3DRMTexture* pTexture)
{
	// existiert Frame und der Rest?
	if (lpD3DRMFrame && pTexture && pTexture->lpD3DRMTexture)
		// ... dann ausfhren
		return lpD3DRMFrame->SetSceneBackgroundImage(pTexture->lpD3DRMTexture);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetSceneBackgroundRGB(D3DVALUE rvRed, D3DVALUE rvGreen,
											D3DVALUE rvBlue)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetSceneBackgroundRGB(rvRed, rvGreen, rvBlue);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetBox(D3DRMBOX* lpD3DRMBox)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetBox(lpD3DRMBox);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetBox(D3DRMBOX* lpD3DRMBox)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->GetBox(lpD3DRMBox);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetBoxEnable(BOOL bEnableFlag)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetBoxEnable(bEnableFlag);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetBoxEnable(BOOL* bBoxEnable)
{
	// existiert Frame?
	if (lpD3DRMFrame)
	{
		// ... dann ausfhren
		*bBoxEnable = lpD3DRMFrame->GetBoxEnable();
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetHierarchyBox(D3DRMBOX* lpD3DRMBox)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->GetHierarchyBox(lpD3DRMBox);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetColor(D3DCOLOR rcColor)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetColor(rcColor);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetColorRGB(D3DVALUE rvRed, D3DVALUE rvGreen,
								  D3DVALUE rvBlue)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetColorRGB(rvRed, rvGreen, rvBlue);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetColor(D3DCOLOR* d3dColor)
{
	// existiert Frame?
	if (lpD3DRMFrame)
	{
		// ... dann ausfhren
		*d3dColor = lpD3DRMFrame->GetColor();
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetSceneFogColor(D3DCOLOR rcColor)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetSceneFogColor(rcColor);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetSceneFogColor(D3DCOLOR* d3dColor)
{
	// existiert Frame?
	if (lpD3DRMFrame)
	{
		// ... dann ausfhren
		*d3dColor = lpD3DRMFrame->GetSceneFogColor();
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetSceneFogEnable(BOOL bEnable)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetSceneFogEnable(bEnable);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetSceneFogEnable(BOOL* bFogEnable)
{
	// existiert Frame?
	if (lpD3DRMFrame)
	{
		// ... dann ausfhren
		*bFogEnable = lpD3DRMFrame->GetSceneFogEnable();
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetSceneFogMode(D3DRMFOGMODE rfMode)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetSceneFogMode(rfMode);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetSceneFogMode(D3DRMFOGMODE* lpFogMode)
{
	// existiert Frame?
	if (lpD3DRMFrame)
	{
		// ... dann ausfhren
		*lpFogMode = lpD3DRMFrame->GetSceneFogMode();
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetSceneFogParams(D3DVALUE rvStart, D3DVALUE rvEnd,
										D3DVALUE rvDensity)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetSceneFogParams(rvStart, rvEnd, rvDensity);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetSceneFogParams(D3DVALUE* lprvStart, D3DVALUE* lprvEnd,
										D3DVALUE* lprvDensity)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->GetSceneFogParams(lprvStart, lprvEnd, lprvDensity);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::AddChild(CDirect3DRMFrame* pD3DRMFrameChild)
{
	// existiert Frame?
	if (lpD3DRMFrame && pD3DRMFrameChild &&
		pD3DRMFrameChild->lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->AddChild(pD3DRMFrameChild->lpD3DRMFrame);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::DeleteChild(CDirect3DRMFrame* pD3DRMFrameChild)
{
	// existiert Frame?
	if (lpD3DRMFrame && pD3DRMFrameChild &&
		pD3DRMFrameChild->lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->DeleteChild(pD3DRMFrameChild->lpD3DRMFrame);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::AddLight(CDirect3DRMLight* pD3DRMLight)
{
	// existiert Frame?
	if (lpD3DRMFrame && pD3DRMLight &&
		pD3DRMLight->lpD3DRMLight)
		// ... dann ausfhren
		return lpD3DRMFrame->AddLight(pD3DRMLight->lpD3DRMLight);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::DeleteLight(CDirect3DRMLight* pD3DRMLight)
{
	// existiert Frame?
	if (lpD3DRMFrame && pD3DRMLight &&
		pD3DRMLight->lpD3DRMLight)
		// ... dann ausfhren
		return lpD3DRMFrame->DeleteLight(pD3DRMLight->lpD3DRMLight);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::Load(LPVOID lpvObjSource, LPVOID lpvObjID, 
						   DXDLL_D3DRMLOADOPTIONS d3drmLOFlags, 
						   DXDLL_D3DRMLOADTEXTURECALLBACK d3drmLoadTextureProc,
						   LPVOID lpArgLTP)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->Load(lpvObjSource, lpvObjID, d3drmLOFlags,
			d3drmLoadTextureProc, lpArgLTP);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetMaterial(CDirect3DRMMaterial* pMaterial)
{
	// existiert Frame?
	if (lpD3DRMFrame && pMaterial && pMaterial->lpD3DRMMaterial)
		// ... dann ausfhren
		return lpD3DRMFrame->SetMaterial(pMaterial->lpD3DRMMaterial);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetMaterialMode(D3DRMMATERIALMODE rmmMode)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetMaterialMode(rmmMode);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetMaterialMode(D3DRMMATERIALMODE* lpMaterial)
{
	// existiert Frame?
	if (lpD3DRMFrame)
	{
		// ... dann ausfhren
		*lpMaterial = lpD3DRMFrame->GetMaterialMode();
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::AddMoveCallback(DXDLL_D3DRMFRAMEMOVECALLBACK d3drmFMC,
									  VOID* lpArg, DWORD dwFlags)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->AddMoveCallback(d3drmFMC, lpArg, dwFlags);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::DeleteMoveCallback(DXDLL_D3DRMFRAMEMOVECALLBACK d3drmFMC,
										 VOID* lpArg)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->DeleteMoveCallback(d3drmFMC, lpArg);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::AddRotation(D3DRMCOMBINETYPE rctCombine, D3DVALUE rvX,
								  D3DVALUE rvY, D3DVALUE rvZ, D3DVALUE rvTheta)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->AddRotation(rctCombine, rvX, rvY, rvZ,
			rvTheta);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::AddScale(D3DRMCOMBINETYPE rctCombine, D3DVALUE rvX,
							   D3DVALUE rvY, D3DVALUE rvZ)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->AddScale(rctCombine, rvX, rvY, rvZ);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::AddTranslation(D3DRMCOMBINETYPE rctCombine, D3DVALUE rvX,
									 D3DVALUE rvY, D3DVALUE rvZ)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->AddTranslation(rctCombine, rvX, rvY, rvZ);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetOrientation(CDirect3DRMFrame* pRef, D3DVALUE rvDx,
									 D3DVALUE rvDy, D3DVALUE rvDz, 
									 D3DVALUE rvUx, D3DVALUE rvUy,
									 D3DVALUE rvUz)
{
	// existiert Frame?
	if (lpD3DRMFrame && pRef && pRef->lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetOrientation(pRef->lpD3DRMFrame,
			rvDx, rvDy, rvDz, rvUx, rvUy, rvUz);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetOrientation(CDirect3DRMFrame* pRef,
									 LPD3DVECTOR lprvDir,
									 LPD3DVECTOR lprvUp)
{
	// existiert Frame?
	if (pRef && pRef->lpD3DRMFrame && lpD3DRMFrame)
		// neu positionieren
		return lpD3DRMFrame->GetOrientation(pRef->lpD3DRMFrame,
			lprvDir, lprvUp);

	// ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetPosition(CDirect3DRMFrame* pRef, D3DVALUE d3dX,
								  D3DVALUE d3dY, D3DVALUE d3dZ)
{
	// existiert Frame?
	if (pRef && pRef->lpD3DRMFrame && lpD3DRMFrame)
		// neu positionieren
		return lpD3DRMFrame->SetPosition(pRef->lpD3DRMFrame, d3dX, d3dY, d3dZ);

	// ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetPosition(CDirect3DRMFrame* pRef, LPD3DVECTOR lprvPos)
{
	// existiert Frame?
	if (pRef && pRef->lpD3DRMFrame && lpD3DRMFrame)
		// neu positionieren
		return lpD3DRMFrame->GetPosition(pRef->lpD3DRMFrame, lprvPos);

	// ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetRotation(CDirect3DRMFrame* pRef, D3DVALUE rvX,
								  D3DVALUE rvY, D3DVALUE rvZ, D3DVALUE rvTheta)
{
	// existiert Frame?
	if (pRef && pRef->lpD3DRMFrame && lpD3DRMFrame)
		// neu positionieren
		return lpD3DRMFrame->SetRotation(pRef->lpD3DRMFrame, rvX,
			rvY, rvZ, rvTheta);

	// ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetRotation(CDirect3DRMFrame* pRef,
								  LPD3DVECTOR lprvAxis, LPD3DVALUE lprvTheta)
{
	// existiert Frame?
	if (pRef && pRef->lpD3DRMFrame && lpD3DRMFrame)
		// neu positionieren
		return lpD3DRMFrame->GetRotation(pRef->lpD3DRMFrame,
			lprvAxis, lprvTheta);

	// ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetVelocity(CDirect3DRMFrame* pRef, D3DVALUE rvX,
								  D3DVALUE rvY, D3DVALUE rvZ, BOOL fRotVel)
{
	// existiert Frame?
	if (pRef && pRef->lpD3DRMFrame && lpD3DRMFrame)
		// neu positionieren
		return lpD3DRMFrame->SetVelocity(pRef->lpD3DRMFrame, rvX,
			rvY, rvZ, fRotVel);

	// ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetVelocity(CDirect3DRMFrame* pRef, LPD3DVECTOR lprvVel,
								  BOOL fRotVel)
{
	// existiert Frame?
	if (pRef && pRef->lpD3DRMFrame && lpD3DRMFrame)
		// neu positionieren
		return lpD3DRMFrame->GetVelocity(pRef->lpD3DRMFrame,
			lprvVel, fRotVel);

	// ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetQuaternion(CDirect3DRMFrame* pRef,
									D3DRMQUATERNION *quat)
{
	// existiert Frame?
	if (pRef && pRef->lpD3DRMFrame && lpD3DRMFrame)
		// neu positionieren
		return lpD3DRMFrame->SetQuaternion(pRef->lpD3DRMFrame, quat);

	// ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::LookAt(CDirect3DRMFrame* pTarget, CDirect3DRMFrame* pRef,
							 D3DRMFRAMECONSTRAINT rfcConstraint)
{
	// existiert Frame?
	if (pRef && pRef->lpD3DRMFrame && lpD3DRMFrame && 
		pTarget && pTarget->lpD3DRMFrame)
		// neu positionieren
		return lpD3DRMFrame->LookAt(pTarget->lpD3DRMFrame,
			pRef->lpD3DRMFrame, rfcConstraint);

	// ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetSortMode(D3DRMSORTMODE d3drmSM)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetSortMode(d3drmSM);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetSortMode(D3DRMSORTMODE* lpSortMode)
{
	// existiert Frame?
	if (lpD3DRMFrame)
	{
		// ... dann ausfhren
		*lpSortMode = lpD3DRMFrame->GetSortMode();
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetZbufferMode(D3DRMZBUFFERMODE d3drmZBM)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->SetZbufferMode(d3drmZBM);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetZbufferMode(D3DRMZBUFFERMODE* lpZBufMode)
{
	// existiert Frame?
	if (lpD3DRMFrame)
	{
		// ... dann ausfhren
		*lpZBufMode = lpD3DRMFrame->GetZbufferMode();
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::SetTexture(CDirect3DRMTexture* pD3DRMTexture)
{
	// existiert Frame?
	if (lpD3DRMFrame && pD3DRMTexture && pD3DRMTexture->lpD3DRMTexture)
		// ... dann ausfhren
		return lpD3DRMFrame->SetTexture(pD3DRMTexture->lpD3DRMTexture);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::AddTransform(D3DRMCOMBINETYPE rctCombine, 
								   D3DRMMATRIX4D rmMatrix)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->AddTransform(rctCombine, rmMatrix);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetTransform(D3DRMMATRIX4D rmMatrix)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->GetTransform(NULL, rmMatrix);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::GetTransform(CDirect3DRMFrame* pFrame,
								   D3DRMMATRIX4D rmMatrix)
{
	// existiert Frame?
	if (lpD3DRMFrame && pFrame && pFrame->lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->GetTransform(pFrame->lpD3DRMFrame, rmMatrix);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::InverseTransform(D3DVECTOR* lprvDst, D3DVECTOR* lprvSrc)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->InverseTransform(lprvDst, lprvSrc);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::Transform(D3DVECTOR* lpd3dVDst, D3DVECTOR* lpd3dVSrc)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->Transform(lpd3dVDst, lpd3dVSrc);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMFrame::DeleteVisual(LPDIRECT3DRMVISUAL lpD3DRMVisual)
{
	// existiert Frame?
	if (lpD3DRMFrame)
		// ... dann ausfhren
		return lpD3DRMFrame->DeleteVisual(lpD3DRMVisual);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

