// Direct3DRMLight.cpp: Implementierung der Klasse CDirect3DRMLight.
//
//////////////////////////////////////////////////////////////////////

#include "Direct3DRMObjects.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDirect3DRMLight::CDirect3DRMLight()
{
	// ... und alles resetten
	lpD3DRMLight = NULL;
}

CDirect3DRMLight::CDirect3DRMLight(LPDIRECT3DRMLIGHT lpLight)
{
	// ... Daten bernehmen
	lpD3DRMLight = lpLight;
}

CDirect3DRMLight::~CDirect3DRMLight()
{
	// ... noch vorher lschen
	DestroyDirect3DLight();
}

void CDirect3DRMLight::DestroyDirect3DLight()
{
	// wurde ein Licht angelegt?
	if (lpD3DRMLight)
	{
		// ... dann zerstren
		lpD3DRMLight->Release();
		lpD3DRMLight = NULL;
	}
}

int CDirect3DRMLight::SetConstantAttenuation(D3DVALUE d3dAttenuation)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
		// ... dann Wert setzen
		return lpD3DRMLight->SetConstantAttenuation(d3dAttenuation);

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::GetConstantAttenuation(D3DVALUE* d3dAttenuation)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
	{
		// Werte ermitteln
		*d3dAttenuation = lpD3DRMLight->GetConstantAttenuation();
		// ... kein Fehlerchen
		return DXDLL_OK;
	}

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::SetLinearAttenuation(D3DVALUE d3dAttenuation)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
		// ... dann Wert setzen
		return lpD3DRMLight->SetLinearAttenuation(d3dAttenuation);

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::GetLinearAttenuation(D3DVALUE* d3dAttenuation)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
	{
		// Werte ermitteln
		*d3dAttenuation = lpD3DRMLight->GetLinearAttenuation();
		// ... kein Fehlerchen
		return DXDLL_OK;
	}

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::SetQuadraticAttenuation(D3DVALUE d3dAttenuation)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
		// ... dann Wert setzen
		return lpD3DRMLight->SetQuadraticAttenuation(d3dAttenuation);

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::GetQuadraticAttenuation(D3DVALUE* d3dAttenuation)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
	{
		// Werte ermitteln
		*d3dAttenuation = lpD3DRMLight->GetQuadraticAttenuation();
		// ... kein Fehlerchen
		return DXDLL_OK;
	}

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::SetColor(D3DCOLOR d3dColor)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
		// ... dann Farbe setzen
		return lpD3DRMLight->SetColor(d3dColor);

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::SetColorRGB(D3DVALUE d3dRed, D3DVALUE d3dGreen, 
								  D3DVALUE d3dBlue)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
		// ... dann Farbe setzen
		return lpD3DRMLight->SetColorRGB(d3dRed, d3dGreen, d3dBlue);

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::GetColor(D3DCOLOR* d3dColor)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
	{
		// Farbe ermitteln
		*d3dColor = lpD3DRMLight->GetColor();
		// ... kein Fehlerchen
		return DXDLL_OK;
	}

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::SetType(D3DRMLIGHTTYPE LightType)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
		// ... dann Lichttypen setzen
		return lpD3DRMLight->SetType(LightType);

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::GetType(D3DRMLIGHTTYPE* lpLightType)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
	{
		// Lichttyp ermitteln
		*lpLightType = lpD3DRMLight->GetType();
		// ... kein Fehlerchen
		return DXDLL_OK;
	}

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::SetRange(D3DVALUE d3dRange)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
		// ... dann Lichttypen setzen
		return lpD3DRMLight->SetRange(d3dRange);

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::GetRange(D3DVALUE* d3dRange)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
	{
		// Bereich ermitteln
		*d3dRange = lpD3DRMLight->GetRange();
		// ... kein Fehlerchen
		return DXDLL_OK;
	}

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::SetUmbra(D3DVALUE d3dUmbra)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
		// ... dann Winkel setzen
		return lpD3DRMLight->SetUmbra(d3dUmbra);

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::GetUmbra(D3DVALUE* d3dUmbra)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
	{
		// Winkel ermitteln
		*d3dUmbra = lpD3DRMLight->GetUmbra();
		// ... kein Fehlerchen
		return DXDLL_OK;
	}

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::SetPenumbra(D3DVALUE d3dPenumbra)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
		// ... dann Winkel setzen
		return lpD3DRMLight->SetPenumbra(d3dPenumbra);

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMLight::GetPenumbra(D3DVALUE* d3dPenumbra)
{
	// wurde eins angelegt?
	if (lpD3DRMLight)
	{
		// Winkel ermitteln
		*d3dPenumbra = lpD3DRMLight->GetPenumbra();
		// ... kein Fehlerchen
		return DXDLL_OK;
	}

	// ... ansonsten trat ein Fehler auf
	return DXDLL_INTERNALERROR;
}

