// Direct3DRMMaterial.cpp: Implementierung der Klasse CDirect3DRMMaterial.
//
//////////////////////////////////////////////////////////////////////

#include "Direct3DRMObjects.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDirect3DRMMaterial::CDirect3DRMMaterial()
{
	// resetten
	lpD3DRMMaterial = NULL;
}

CDirect3DRMMaterial::CDirect3DRMMaterial(DXDLL_LPDIRECT3DRMMATERIAL lpMaterial)
{
	// ... Werte bernehmen
	lpD3DRMMaterial = lpMaterial;
}

CDirect3DRMMaterial::~CDirect3DRMMaterial()
{
	// noch vorher alles auslschen
	DestroyDirect3DMaterial();
}

void CDirect3DRMMaterial::DestroyDirect3DMaterial()
{
	// Material definiert?
	if (lpD3DRMMaterial)
	{
		// ... dann lschen
		lpD3DRMMaterial->Release();
		lpD3DRMMaterial = NULL;
	}
}

int CDirect3DRMMaterial::SetEmissive(D3DVALUE d3dr, D3DVALUE d3dg,
									 D3DVALUE d3db)
{
	// ist ein Material definiert?
	if (lpD3DRMMaterial)
		// ... dann Emissionseigenschaft setzen
		return lpD3DRMMaterial->SetEmissive(d3dr, d3dg, d3db);

	// ... ansonsten gab's nur einen Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMMaterial::GetEmissive(D3DVALUE* d3dr, D3DVALUE* d3dg, 
									 D3DVALUE* d3db)
{
	// ist ein Material definiert?
	if (lpD3DRMMaterial)
		// ... dann Emissionseigenschaft ermitteln
		return lpD3DRMMaterial->GetEmissive(d3dr, d3dg, d3db);

	// ... ansonsten gab's nur einen Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMMaterial::SetSpecular(D3DVALUE d3dr, D3DVALUE d3dg,
									 D3DVALUE d3db)
{
	// ist ein Material definiert?
	if (lpD3DRMMaterial)
		// ... dann Emissionseigenschaft setzen
		return lpD3DRMMaterial->SetSpecular(d3dr, d3dg, d3db);

	// ... ansonsten gab's nur einen Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMMaterial::GetSpecular(D3DVALUE* d3dr, D3DVALUE* d3dg, 
									 D3DVALUE* d3db)
{
	// ist ein Material definiert?
	if (lpD3DRMMaterial)
		// ... dann Emissionseigenschaft ermitteln
		return lpD3DRMMaterial->GetSpecular(d3dr, d3dg, d3db);

	// ... ansonsten gab's nur einen Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMMaterial::SetPower(D3DVALUE d3dPower)
{
	// ist ein Material definiert?
	if (lpD3DRMMaterial)
		// ... dann Emissionseigenschaft ermitteln
		return lpD3DRMMaterial->SetPower(d3dPower);

	// ... ansonsten gab's nur einen Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMMaterial::GetPower(D3DVALUE* d3dPower)
{
	// ist ein Material definiert?
	if (lpD3DRMMaterial)
	{
		// ... dann Emissionseigenschaft ermitteln
		*d3dPower = lpD3DRMMaterial->GetPower();
		// und kein Fehler
		return DXDLL_OK;
	}

	// ... ansonsten gab's nur einen Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMMaterial::SetAmbient(D3DVALUE dvRed, D3DVALUE dvGreen, 
									D3DVALUE dvBlue)
{
	// ist ein Material definiert?
	if (lpD3DRMMaterial)
		// Material setzen
		return lpD3DRMMaterial->SetAmbient(dvRed, dvGreen, dvBlue);

	// ... ansonsten gab's nur einen Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMMaterial::GetAmbient(LPD3DVALUE lpdvRed, LPD3DVALUE lpdvGreen, 
									LPD3DVALUE lpdvBlue)
{
	// ist ein Material definiert?
	if (lpD3DRMMaterial)
		// Material setzen
		return lpD3DRMMaterial->GetAmbient(lpdvRed, lpdvGreen, lpdvBlue);

	// ... ansonsten gab's nur einen Fehler
	return DXDLL_INTERNALERROR;
}

