// Direct3DRMTexture.cpp: Implementierung der Klasse CDirect3DRMTexture.
//
//////////////////////////////////////////////////////////////////////

#include "Direct3DRMObjects.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDirect3DRMTexture::CDirect3DRMTexture()
{
	// alle resetten
	lpD3DRMTexture = NULL;
}

CDirect3DRMTexture::CDirect3DRMTexture(DXDLL_LPDIRECT3DRMTEXTURE lpTexture)
{
	// alle Daten bernehmen
	lpD3DRMTexture = lpTexture;
}

CDirect3DRMTexture::~CDirect3DRMTexture()
{
	// noch vorher Interface zerstren
	DestroyDirect3DTexture();
}

void CDirect3DRMTexture::DestroyDirect3DTexture()
{
	// Material definiert?
	if (lpD3DRMTexture)
	{
		// ... dann lschen
		lpD3DRMTexture->Release();
		lpD3DRMTexture = NULL;
	}
}

int CDirect3DRMTexture::SetColors(DWORD dwColors)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
		// ... dann Anzahl setzen
		return lpD3DRMTexture->SetColors(dwColors);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::GetColors(DWORD* dwColors)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
	{
		// ... dann Anzahl ermitteln
		*dwColors = lpD3DRMTexture->GetColors();
		// und kein Fehler
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::SetDecalOrigin(LONG lx, LONG ly)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
		// ... dann Position setzen
		return lpD3DRMTexture->SetDecalOrigin(lx, ly);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::GetDecalOrigin(LONG* lx, LONG* ly)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
		// ... dann Position ermitteln
		return lpD3DRMTexture->GetDecalOrigin(lx, ly);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::SetDecalScale(DWORD dwScale)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
		// ... dann Skalierungsfaktor setzen
		return lpD3DRMTexture->SetDecalScale(dwScale);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::GetDecalScale(DWORD* dwScale)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
	{
		// ... dann Skalierungsfaktor ermitteln
		*dwScale = lpD3DRMTexture->GetDecalScale();
		// und kein Fehler
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::SetDecalSize(D3DVALUE d3dWidth, D3DVALUE d3dHeight)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
		// ... dann Gre setzen
		return lpD3DRMTexture->SetDecalSize(d3dWidth, d3dHeight);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::GetDecalSize(D3DVALUE* d3dWidth, D3DVALUE* d3dHeight)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
		// ... dann Gre ermitteln
		return lpD3DRMTexture->GetDecalSize(d3dWidth, d3dHeight);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::SetDecalTransparency(BOOL bTransp)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
		// ... dann Transparenz setzen
		return lpD3DRMTexture->SetDecalTransparency(bTransp);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::GetDecalTransparency(BOOL* bTransp)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
	{
		// ... dann Transparenz ermitteln
		*bTransp = lpD3DRMTexture->GetDecalTransparency();
		// und kein Fehler
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::SetDecalTransparentColor(D3DCOLOR d3dColor)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
		// ... dann Farbe setzen
		return lpD3DRMTexture->SetDecalTransparentColor(d3dColor);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::GetDecalTransparentColor(D3DCOLOR* d3dColor)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
	{
		// ... dann Farbe ermitteln
		*d3dColor = lpD3DRMTexture->GetDecalTransparentColor();
		// und kein Fehler
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::GetImage(D3DRMIMAGE* lpImage)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
	{
		// ... dann Imageeigenschaften ermitteln
		lpImage = lpD3DRMTexture->GetImage();
		// und kein Fehler
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::GenerateMIPMap()
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
		// ... generieren
		return lpD3DRMTexture->GenerateMIPMap(0);

	// Fehlermeldung, falls nicht existent
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::Changed(DWORD dwFlags, DWORD dwcRects, LPRECT pRects)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
		// ... generieren
		return lpD3DRMTexture->Changed(dwFlags, dwcRects, pRects);

	// Fehlermeldung, falls nicht existent
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::SetShades(DWORD dwMaxShades)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
		// ... dann maximale Anzahl Schatten setzen
		return lpD3DRMTexture->SetShades(dwMaxShades);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMTexture::GetShades(DWORD* dwMaxShades)
{
	// existiert ein Objekt?
	if (lpD3DRMTexture)
	{
		// ... dann maximale Anzahl Schatten ermitteln
		*dwMaxShades = lpD3DRMTexture->GetShades();
		// und kein Fehler
		return DXDLL_OK;
	}

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

LPDIRECT3DRMVISUAL CDirect3DRMTexture::GetVisual()
{
	// und das ganze zurckliefern
	return (LPDIRECT3DRMVISUAL)lpD3DRMTexture;
}

