// Direct3DRMWrap.cpp: Implementierung der Klasse CDirect3DRMWrap.
//
//////////////////////////////////////////////////////////////////////

#include "Direct3DRM.h"
#include "Direct3DRMObjects.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDirect3DRMWrap::CDirect3DRMWrap()
{
	// alles resetten
	lpD3DRMWrap = NULL;
}

CDirect3DRMWrap::CDirect3DRMWrap(LPDIRECT3DRMWRAP lpWrap)
{
	// hier alles bernehmen
	lpD3DRMWrap = lpWrap;
}

CDirect3DRMWrap::~CDirect3DRMWrap()
{
	// noch vorher alles zerstren
	DestroyDirect3DWrap();
}

void CDirect3DRMWrap::DestroyDirect3DWrap()
{
	// existiert das Objekt?
	if (lpD3DRMWrap)
	{
		// ... dann lschen
		lpD3DRMWrap->Release();
		lpD3DRMWrap = NULL;
	}
}

int CDirect3DRMWrap::Apply(LPDIRECT3DRMOBJECT lpD3DRMObject)
{
	// existiert Wrap?
	if (lpD3DRMWrap)
		// ... dann Befehl ausfhren
		return lpD3DRMWrap->Apply(lpD3DRMObject);

	// ... sonst Fehler
	return DXDLL_INTERNALERROR;
}

int CDirect3DRMWrap::ApplyRelative(CDirect3DRMFrame* pFrame,
								   LPDIRECT3DRMOBJECT lpD3DRMObject)
{
	// existiert Wrap?
	if (lpD3DRMWrap && pFrame)
		// existiert auch eine Frame-Schnittstelle
		if (pFrame->lpD3DRMFrame)
			// ... dann Befehl ausfhren
			return lpD3DRMWrap->ApplyRelative(
				(LPDIRECT3DRMFRAME)pFrame->lpD3DRMFrame,
				lpD3DRMObject);

	// ... sonst Fehler
	return DXDLL_INTERNALERROR;
}

