// DirectDrawSurface.cpp: Implementierung der Klasse CDirectDrawSurface.
//
//////////////////////////////////////////////////////////////////////

#include "DirectDraw.h"
#include "DirectInfo.h"


static HRESULT WINAPI EnumZBufferCallback(DXDLL_DDPIXELFORMAT* pddpf,
										  VOID* pddpfDesired)
{
	DXDLL_FINDZBUFFER* pFindZBuffer = (DXDLL_FINDZBUFFER*)pddpfDesired;

	// ist es gltig?
	if (pFindZBuffer)
	{
		// ein ZBuffer wurde geliefert
		if(pddpf->dwFlags == DDPF_ZBUFFER)
		{
			// mal schauen, ob dies dem Format entspricht
			if (pFindZBuffer->dwFindBits == pddpf->dwZBufferBitDepth ||
				pFindZBuffer->dwFindBits == 0)
			{
				// Block kopieren
				memcpy(&(pFindZBuffer->ddpfFoundFormat), pddpf, 
					sizeof(DXDLL_DDPIXELFORMAT));

/*				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwSize);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwFlags);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwFourCC);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwRGBBitCount);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwYUVBitCount);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwZBufferBitDepth);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwAlphaBitDepth);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwLuminanceBitCount);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwBumpBitCount);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwRBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwYBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwStencilBitDepth);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwLuminanceBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwBumpDuBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwGBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwUBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwZBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwBumpDvBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwBBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwVBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwStencilBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwBumpLuminanceBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwRGBAlphaBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwYUVAlphaBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwLuminanceAlphaBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwRGBZBitMask);
				WriteLOGLine("\n");
				WriteLOGHResult(pFindZBuffer->ddpfFoundFormat.dwYUVZBitMask);
				WriteLOGLine("\n");
				WriteLOGSoftEndSection();*/

				// und Suche abbrechen
				return D3DENUMRET_CANCEL;
			}
		}
	}

	// weiter suchen
	return D3DENUMRET_OK;
}


//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDirectDrawSurface::CDirectDrawSurface()
{
	// als erstes mal Einstellungen leeren
	ZeroMemory(&ddsdesc, sizeof(ddsdesc));
	// Surfaces auf null setzen
	lpSurface = NULL;
//	lpClipper = NULL;
	// ... und auch das DirectDraw-Objekt
	pDirectDraw = NULL;
	pDDFadeSurface = NULL;
}

CDirectDrawSurface::CDirectDrawSurface(CDirectDraw* pDD)
{
	// als erstes mal Einstellungen leeren
	ZeroMemory(&ddsdesc, sizeof(ddsdesc));
	// Surfaces auf null setzen
	lpSurface = NULL;
//	lpClipper = NULL;
	// ... noch DirectDraw-Objekt bernehmen
	pDirectDraw = pDD;
	pDDFadeSurface = NULL;
}

CDirectDrawSurface::~CDirectDrawSurface()
{
	// Surfacebeziehungen zerstren
	DestroyCompleteSurface();
}

void CDirectDrawSurface::DestroySurface()
{
	// ist schon ein Surface angelegt?
	if (lpSurface)
	{
		// ... dann Hauptsurface freigeben
		lpSurface->Release();
		lpSurface = NULL;
	}
	// ist schon ein Clipper angelegt?
/*	if (lpClipper)
	{
		// ... dann Hauptsurface freigeben
		lpClipper->Release();
		lpClipper = NULL;
	}*/
}

void CDirectDrawSurface::DestroyCompleteSurface()
{
	// Surface lschen
	DestroySurface();
	DestroyFadeSurface();
}

void CDirectDrawSurface::SetSurfaceDescData(DWORD dwFlags, DWORD dwBackBuffer,
											DWORD dwCaps)
{
	// aktuellen Inhalt lschen
	ZeroMemory(&ddsdesc, sizeof(ddsdesc));
	// ... und mit neuen Daten belegen
	ddsdesc.dwSize = sizeof(ddsdesc);
	// sind Hintergrundbuffer vorgesehen?
	if (dwBackBuffer > 0)
		// ... dann dieses Flag mit einbeziehen
		ddsdesc.dwFlags = dwFlags | DDSD_BACKBUFFERCOUNT;
	else
		// ... ansonsten nur bernehmen
		ddsdesc.dwFlags = dwFlags;
	// ... und Anzahl Hintergrundbuffer angeben
	ddsdesc.dwBackBufferCount = dwBackBuffer;
	// und Caps angeben
	ddsdesc.ddsCaps.dwCaps = dwCaps;
}

void CDirectDrawSurface::SetSurfaceDescData(DXDLL_DDSURFACEDESC* lpddsd)
{
	// Inhalt kopieren
	CopyMemory(&ddsdesc, lpddsd, sizeof(DXDLL_DDSURFACEDESC));
}

int CDirectDrawSurface::CreatePrimarySurface()
{
	// wenigstens zu einem DirectDraw-Objekt verbunden?
	if (pDirectDraw)
	{
		// Surfacebeziehungen zerstren
		DestroySurface();

		// wurde bereits das DDSD_CAPS-Flag belegt?
		if (!(ddsdesc.dwFlags & DDSD_CAPS))
			ddsdesc.dwFlags = ddsdesc.dwFlags | DDSD_CAPS;

		// wenn Primary-Flag noch nicht gesetzt, dann setzen
		if (!(ddsdesc.ddsCaps.dwCaps & DDSCAPS_PRIMARYSURFACE))
			// ... noch Daten fr Primary hinzufgen
			ddsdesc.ddsCaps.dwCaps = ddsdesc.ddsCaps.dwCaps | DDSCAPS_PRIMARYSURFACE;

		// und erzeugen
		if (FAILED(pDirectDraw->lpDD->CreateSurface(&ddsdesc, &lpSurface, NULL)))
			// fals Fehler raus
			return Fail(pDirectDraw->hWindow, DXDLL_MSGERROR_PRIMARYSURFACECREATE);

		// Auflsung des Surfaces speichern
		iSurfaceWidth = pDirectDraw->iBSWidth;
		iSurfaceHeight = pDirectDraw->iBSHeight;

		// und alles ok
		return DXDLL_OK;
	}
	else
		return DXDLL_INTERNALERROR;
}


CDirectDrawSurface* CDirectDrawSurface::GetAttachedSurface(DXDLL_DDSCAPS dsCaps)
{
	DXDLL_LPDIRECTDRAWSURFACE lpSurfaceTemp;
	CDirectDrawSurface* pSurface;
	
	if (FAILED(lpSurface->GetAttachedSurface(&dsCaps, &lpSurfaceTemp)))
	{
		// ... dann eben Fehlermeldung
		Fail(pDirectDraw->hWindow, DXDLL_MSGERROR_ATTACHEDSURFACEGET);
		// und auch das zurckliefern
		return NULL;
	}

	// falls alles ok, dann neue Klasse erzeugen
	pSurface = new CDirectDrawSurface(pDirectDraw);
	// ... und Surface setzen
	pSurface->lpSurface = lpSurfaceTemp;

	// Auflsung des Surfaces speichern
	pSurface->iSurfaceWidth = this->iSurfaceWidth;
	pSurface->iSurfaceHeight = this->iSurfaceHeight;

	// und Zeiger auf Klasse zurckliefern
	return pSurface;
}

int CDirectDrawSurface::CreateSurface(DXDLL_DDSURFACEDESC* lpDesc)
{
	// wenigstens zu einem DirectDraw-Objekt verbunden?
	if (pDirectDraw)
	{
		// Surfacebeziehungen zerstren
		DestroySurface();

		// noch Caps kopieren
		CopyMemory(&ddsdesc, lpDesc, sizeof(DXDLL_DDSURFACEDESC));

		// und Hauptsurface erzeugen
		if (FAILED(pDirectDraw->lpDD->CreateSurface(&ddsdesc, &lpSurface, NULL)))
		{
			// bei Fehler auf Systemmemory ausweichen
			ddsdesc.ddsCaps.dwCaps = ddsdesc.ddsCaps.dwCaps | DDSCAPS_SYSTEMMEMORY;
			// und erneut anlegen
			if (FAILED(pDirectDraw->lpDD->CreateSurface(&ddsdesc, 
					&lpSurface, NULL)))
				// fals Fehler raus
				return Fail(pDirectDraw->hWindow, DXDLL_MSGERROR_SURFACECREATE);
		}

		// Auflsung des Surfaces speichern
		iSurfaceWidth = lpDesc->dwWidth;
		iSurfaceHeight = lpDesc->dwHeight;

		// und alles ok
		return DXDLL_OK;
	}
	else
		return DXDLL_INTERNALERROR;
}

int CDirectDrawSurface::CreateOffscreenSurface(DWORD dwWidth, DWORD dwHeight)
{
	// wenigstens zu einem DirectDraw-Objekt verbunden?
	if (pDirectDraw)
	{
		// Surfacebeziehungen zerstren
		DestroySurface();

		// noch Breite, Hhe angeben
		ddsdesc.dwHeight = dwHeight;
		ddsdesc.dwWidth = dwWidth;

		// wurde bereits das DDSD_CAPS-Flag belegt?
		if (!(ddsdesc.dwFlags & DDSD_CAPS))
			ddsdesc.dwFlags |= DDSD_CAPS;
		// Hhen-Flag schon gesetzt?
		if (!(ddsdesc.dwFlags & DDSD_HEIGHT))
			ddsdesc.dwFlags |= DDSD_HEIGHT;
		// Breiten-Flag schon gesetzt?
		if (!(ddsdesc.dwFlags & DDSD_WIDTH))
			ddsdesc.dwFlags |= DDSD_WIDTH;

		// Offsreenplain-Flag gesetzt?
		if (ddsdesc.ddsCaps.dwCaps & DDSCAPS_OFFSCREENPLAIN)
			ddsdesc.ddsCaps.dwCaps |= DDSCAPS_OFFSCREENPLAIN;

		// und Hauptsurface erzeugen
		if (FAILED(pDirectDraw->lpDD->CreateSurface(&ddsdesc, &lpSurface, NULL)))
		{
			// bei Fehler auf Systemmemory ausweichen
			ddsdesc.ddsCaps.dwCaps = ddsdesc.ddsCaps.dwCaps | DDSCAPS_SYSTEMMEMORY;
			// und erneut anlegen
			if (FAILED(pDirectDraw->lpDD->CreateSurface(&ddsdesc, 
					&lpSurface, NULL)))
				// fals Fehler raus
				return Fail(pDirectDraw->hWindow, 
					DXDLL_MSGERROR_OFFSCREENSURFACECREATE);
		}

		// Auflsung des Surfaces speichern
		iSurfaceWidth = dwWidth;
		iSurfaceHeight = dwHeight;

		// und alles ok
		return DXDLL_OK;
	}
	else
		return DXDLL_INTERNALERROR;
}

int CDirectDrawSurface::CreateZBuffer(DWORD dwWidth, DWORD dwHeight,
									  DWORD dwZBufferBitDepth,
									  CDirectXDriverInfo* pD3DInfo)
{
	// wenigstens zu einem DirectDraw-Objekt verbunden?
	if (pDirectDraw && pD3DInfo && 
		pD3DInfo->GetDriverDeviceType() == DXI_DIRECT3D)
	{
		LPDIRECT3D3 lpD3D;
		DXDLL_FINDZBUFFER FindZBuffer;

		bool bHardware = false;
		LPD3DDEVICEDESC lpDesc;
		LPD3DDEVICEDESC lpHELDesc = (LPD3DDEVICEDESC)
			pD3DInfo->GetDriverDescInfoHEL();
		LPD3DDEVICEDESC lpHALDesc = (LPD3DDEVICEDESC)
			pD3DInfo->GetDriverDescInfoHAL();
		
		// ... um den ZBuffer suchen zu knnen ein D3D-Objekt anlegen
		if (SUCCEEDED(pDirectDraw->lpDD->
				QueryInterface(IID_IDirect3D3, (LPVOID*)&lpD3D)))
		{
			// wir suchen den Buffer mit diesen Biteinstellungen
			FindZBuffer.dwFindBits = dwZBufferBitDepth;
			// aufzhlen und suchen
			if (SUCCEEDED(lpD3D->EnumZBufferFormats(
					*pD3DInfo->GetDriverGUID(),	EnumZBufferCallback, 
					(VOID*)&FindZBuffer)))
			{
				// bestimmen, ob Hardware oder Software
				if (lpHALDesc->dcmColorModel)
				{
					// Farbmodell belegt, also Hardware
					lpDesc = lpHALDesc;
					bHardware = true;
				}
				else
					// ... ansonsten Software
					lpDesc = lpHELDesc;

				// Surfacebeziehungen zerstren
				DestroySurface();

				// wurde bereits das DDSD_CAPS-Flag belegt?
				if (!(ddsdesc.dwFlags & DDSD_CAPS))
					ddsdesc.dwFlags |= DDSD_CAPS;
				// Hhen-Flag schon gesetzt?
				if (!(ddsdesc.dwFlags & DDSD_HEIGHT))
					ddsdesc.dwFlags |= DDSD_HEIGHT;
				// Breiten-Flag schon gesetzt?
				if (!(ddsdesc.dwFlags & DDSD_WIDTH))
					ddsdesc.dwFlags |= DDSD_WIDTH;
 
				// Pixelformat-Flag schon gesetzt?
				if (!(ddsdesc.dwFlags & DDSD_PIXELFORMAT))
					ddsdesc.dwFlags |= DDSD_PIXELFORMAT;

				// ZBuffer-Flag gesetzt?
				if (!(ddsdesc.ddsCaps.dwCaps & DDSCAPS_ZBUFFER))
					ddsdesc.ddsCaps.dwCaps |= DDSCAPS_ZBUFFER;

				// gefundenes Pixelformat kopieren
				memcpy(&ddsdesc.ddpfPixelFormat, &FindZBuffer.ddpfFoundFormat,
					sizeof(DXDLL_DDPIXELFORMAT));

				if (bHardware == true)
				{
					// ... ansonsten mal gucken, ob schon ein Flag angegeben
					if ((!(ddsdesc.ddsCaps.dwCaps & DDSCAPS_SYSTEMMEMORY)) &&
						(!(ddsdesc.ddsCaps.dwCaps & DDSCAPS_VIDEOMEMORY)))
						// ... und in Videospeicher, da Hardware
						ddsdesc.ddsCaps.dwCaps |= DDSCAPS_VIDEOMEMORY;
				}
				else
				{
					// ... ansonsten mal gucken, ob schon ein Flag angegeben
					if ((!(ddsdesc.ddsCaps.dwCaps & DDSCAPS_SYSTEMMEMORY)) &&
						(!(ddsdesc.ddsCaps.dwCaps & DDSCAPS_VIDEOMEMORY)))
						// ... und in Systemspeicher, da Software
						ddsdesc.ddsCaps.dwCaps |= DDSCAPS_SYSTEMMEMORY;
				}

				// noch Breite, Hhe angeben
				ddsdesc.dwHeight = dwHeight;
				ddsdesc.dwWidth = dwWidth;

				// und Hauptsurface erzeugen
				if (FAILED(pDirectDraw->lpDD->CreateSurface(&ddsdesc, &lpSurface, NULL)))
					// falls Fehler raus
					return Fail(pDirectDraw->hWindow, DXDLL_MSGERROR_ZBUFFERSURFACECREATE);

				// Auflsung des Surfaces speichern
				iSurfaceWidth = dwWidth;
				iSurfaceHeight = dwHeight;

				// und alles ok
				return DXDLL_OK;
			}

			// Direct3D-Objekt freigeben
			lpD3D->Release();
		}
	}

	// immer Fehler in diesem Zweig
	return DXDLL_INTERNALERROR;
}

HBITMAP CDirectDrawSurface::LoadBitmap(DWORD dwWidth, DWORD dwHeight,
									   LPCSTR pFilename, LPCSTR pResName,
									   HINSTANCE Instance, bool bDestroyBMP)
{
	// wenigstens mit DirectDraw-Objekt verbunden
	if (pDirectDraw)
	{
		HDC hDDSDC;
		HDC hDC;
		BITMAP bm;
		BITMAP bmtmp;
		HBITMAP hbm;

		// Bitmap von Platte laden
		if ((hbm = (HBITMAP)LoadImage(NULL, pFilename, IMAGE_BITMAP,
					0, 0, LR_CREATEDIBSECTION | LR_LOADFROMFILE)) == NULL)
			// bei Fehler aus Ressource
			hbm = (HBITMAP)::LoadBitmap(Instance, pResName);

		// Handle gltig?
		if (hbm)
		{
			// DC erzeugen
			hDC = CreateCompatibleDC(NULL);
			// ... dann Bitmap selektieren
			SelectObject(hDC, hbm);

			// Einstellungen belegen
			SetSurfaceDescData(DDSD_CAPS, 0, 0);
			// Hhe, Breite = 0?
			if (dwHeight == 0 && dwWidth == 0)
				// ... dann Breite und Hhe des Bitmaps ermitteln
				GetObject(hbm, sizeof(bmtmp), &bmtmp);
			else
			{
				// ... ansonsten feste Werte setzen
				bmtmp.bmHeight = dwHeight;
				bmtmp.bmWidth = dwWidth;
			}

			// ... und Surface erzeugen (bei Erfolg weiter)
			if (SUCCEEDED(CreateOffscreenSurface(bmtmp.bmWidth, bmtmp.bmHeight)))
			{
				// Auflsung holen
				GetObject(hbm, sizeof(bm), &bm);

				// und Bitmap drauf kopieren
				lpSurface->GetDC(&hDDSDC);
				StretchBlt(hDDSDC, 0, 0, bmtmp.bmWidth, bmtmp.bmHeight, hDC, 
					0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY);

				// und DC wieder zerstren
				lpSurface->ReleaseDC(hDDSDC);
				DeleteDC(hDC);

				// soll BMP wieder zerstrt werden?
				if (bDestroyBMP == true)
					// ... dann lschen
					DeleteObject(hbm);

				// und neues Handle zurckliefern
				return hbm;
			}
		}
	}

	return DXDLL_OK;
}

HBITMAP CDirectDrawSurface::CopyBitmap(DWORD dwWidth, DWORD dwHeight,
									   LPCSTR pFilename, LPCSTR pResName,
									   HINSTANCE Instance, bool bDestroyBMP)
{
	// wenigstens mit DirectDraw-Objekt verbunden
	if (pDirectDraw)
	{
		HDC hDDSDC;
		HDC hDC;
		BITMAP bm;
		BITMAP bmtmp;
		HBITMAP hbm;

		// Bitmap von Platte laden
		if ((hbm = (HBITMAP)LoadImage(NULL, pFilename, IMAGE_BITMAP,
					0, 0, LR_CREATEDIBSECTION | LR_LOADFROMFILE)) == NULL)
			// bei Fehler aus Ressource
			hbm = (HBITMAP)::LoadBitmap(Instance, pResName);

		// Handle gltig?
		if (hbm)
		{
			// DC erzeugen
			hDC = CreateCompatibleDC(NULL);
			// ... dann Bitmap selektieren
			SelectObject(hDC, hbm);

			// Hhe, Breite = 0?
			if (dwHeight == 0 && dwWidth == 0)
			{
				// ... dann Breite und Hhe des Surfaces ermitteln
				bmtmp.bmHeight = iSurfaceHeight;
				bmtmp.bmWidth = iSurfaceWidth;
				// Auflsung von BMP holen
				GetObject(hbm, sizeof(bm), &bm);
			}
			else
			{
				// ... ansonsten feste Werte setzen
				bmtmp.bmHeight = dwHeight;
				bmtmp.bmWidth = dwWidth;
				// ... und noch Bitmapgre setzen
				bm.bmHeight = dwHeight;
				bm.bmWidth = dwWidth;
			}


			// und Bitmap drauf kopieren
			lpSurface->GetDC(&hDDSDC);
			StretchBlt(hDDSDC, 0, 0, bmtmp.bmWidth, bmtmp.bmHeight, hDC, 
				0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY);

			// und DC wieder zerstren
			lpSurface->ReleaseDC(hDDSDC);
			DeleteDC(hDC);

			// soll BMP wieder zerstrt werden?
			if (bDestroyBMP == true)
				// ... dann lschen
				DeleteObject(hbm);

			// und neues Handle zurckliefern
			return hbm;
		}
	}

	return DXDLL_OK;
}

int CDirectDrawSurface::CopyBitmap(DWORD dwWidth, DWORD dwHeight,
								   HBITMAP hbm)
{
	// wenigstens mit DirectDraw-Objekt verbunden
	if (pDirectDraw)
	{
		HDC hDDSDC;
		HDC hDC;
		BITMAP bm;
		BITMAP bmtmp;

		// Handle gltig?
		if (hbm)
		{
			// DC erzeugen
			hDC = CreateCompatibleDC(NULL);
			// ... dann Bitmap selektieren
			SelectObject(hDC, hbm);

			// Hhe, Breite = 0?
			if (dwHeight == 0 && dwWidth == 0)
			{
				// ... dann Breite und Hhe des Surfaces ermitteln
				bmtmp.bmHeight = iSurfaceHeight;
				bmtmp.bmWidth = iSurfaceWidth;
				// Auflsung von BMP holen
				GetObject(hbm, sizeof(bm), &bm);
			}
			else
			{
				// ... ansonsten feste Werte setzen
				bmtmp.bmHeight = dwHeight;
				bmtmp.bmWidth = dwWidth;
				// ... und noch Bitmapgre setzen
				bm.bmHeight = dwHeight;
				bm.bmWidth = dwWidth;
			}


			// und Bitmap drauf kopieren
			lpSurface->GetDC(&hDDSDC);
			StretchBlt(hDDSDC, 0, 0, bmtmp.bmWidth, bmtmp.bmHeight, hDC, 
				0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY);

			// und DC wieder zerstren
			lpSurface->ReleaseDC(hDDSDC);
			DeleteDC(hDC);

			// und neues Handle zurckliefern
			return DXDLL_OK;
		}
	}

	return DXDLL_INTERNALERROR;
}

HBITMAP CDirectDrawSurface::CopySurface(DWORD dwWidth, DWORD dwHeight)
{
	HBITMAP hbm = NULL;

	// wenigstens mit DirectDraw-Objekt verbunden
	if (pDirectDraw)
	{
		HDC hDDSDC;
		HDC hDC;
		BITMAP bm;
		HBITMAP hOldBM;

		// Handle gltig?
		if (lpSurface)
		{
			// DC auf aktuelles Surface holen
			if (SUCCEEDED(lpSurface->GetDC(&hDDSDC)))
			{
				// DC auf Basis des Surface-DC's erzeugen
				hDC = CreateCompatibleDC(hDDSDC);
				// gltig?
				if (hDC)
				{
					// Hhe, Breite = 0?
					if (dwHeight == 0 && dwWidth == 0)
					{
						// ... dann Breite und Hhe des Surfaces ermitteln
						bm.bmHeight = iSurfaceHeight;
						bm.bmWidth = iSurfaceWidth;
					}
					else
					{
						// ... ansonsten feste Werte setzen
						bm.bmHeight = dwHeight;
						bm.bmWidth = dwWidth;
					}

					// Bitmap mit angegebener Gre erzeugen
					hbm = CreateCompatibleBitmap(hDC, bm.bmWidth,
						bm.bmHeight);
					// gltig?
					if (hbm)
					{
						// ... dann dieses Bitmap selektieren
						hOldBM = (HBITMAP)SelectObject(hDC, hbm);
						// ... jetzt kopieren
						BitBlt(hDC, 0, 0, bm.bmWidth, bm.bmHeight, hDDSDC, 
							0, 0, SRCCOPY);
						// altes BMP wieder selektieren
						SelectObject(hDC, hOldBM);
					}
					// BMP-DC auslschen
					DeleteDC(hDC);
				}
				// und Surface-DC wieder zerstren
				lpSurface->ReleaseDC(hDDSDC);
			}
		}
	}

	return hbm;
}

int CDirectDrawSurface::Lock(LPRECT lpDestRect, 
							 DXDLL_DDSURFACEDESC* lpDDSurfaceDesc, 
							 DWORD dwDescFlags, DWORD dwFlags)
{
	// mit Daten fllen
	ZeroMemory(lpDDSurfaceDesc, sizeof(DXDLL_DDSURFACEDESC));
	lpDDSurfaceDesc->dwSize = sizeof(DXDLL_DDSURFACEDESC);
	lpDDSurfaceDesc->dwFlags = dwDescFlags;

	// Sperren der Oberflche ausfhren
	return lpSurface->Lock(lpDestRect, lpDDSurfaceDesc, dwFlags, NULL);
}

int CDirectDrawSurface::Lock(DXDLL_DDSURFACEDESC* lpDDSurfaceDesc, 
							 DWORD dwDescFlags, DWORD dwFlags)
{
	// mit Daten fllen
	ZeroMemory(lpDDSurfaceDesc, sizeof(DXDLL_DDSURFACEDESC));
	lpDDSurfaceDesc->dwSize = sizeof(DXDLL_DDSURFACEDESC);
	lpDDSurfaceDesc->dwFlags = dwDescFlags;

	// Sperren der Oberflche ausfhren
	return lpSurface->Lock(NULL, lpDDSurfaceDesc, dwFlags, NULL);
}

int CDirectDrawSurface::Unlock(LPVOID lpSurfaceData)
{
	// Entsperren der Oberflche ausfhren
	return lpSurface->Unlock((LPRECT)lpSurfaceData);
}

int CDirectDrawSurface::Unlock()
{
	// Entsperren der Oberflche ausfhren
	return lpSurface->Unlock(NULL);
}

int CDirectDrawSurface::Flip(CDirectDrawSurface *pDDSurfaceTargetOverride, 
							 DWORD dwFlags)
{
	// ... soll eine beliebige draufkopiert werden?
	if (pDDSurfaceTargetOverride)
		// ... machmer das mal
		return lpSurface->Flip(pDDSurfaceTargetOverride->lpSurface, dwFlags);
	else
		// ... ansonsten eben das festgelegte
		return lpSurface->Flip(NULL, dwFlags);
}

int CDirectDrawSurface::Flip(DWORD dwFlags)
{
	// ... ansonsten eben das festgelegte
	return lpSurface->Flip(NULL, dwFlags);
}

int CDirectDrawSurface::Flip()
{
	// ... ansonsten eben das festgelegte
	return lpSurface->Flip(NULL, DDFLIP_WAIT);
}

int CDirectDrawSurface::BltFast(DWORD dwx, DWORD dwy, 
								CDirectDrawSurface *pSurface, 
								LPRECT lpRect, DWORD dwTrans)
{
	// BltFast ausfhren
	return lpSurface->BltFast(dwx, dwy, pSurface->lpSurface, 
		lpRect, dwTrans);
}

int CDirectDrawSurface::BltFast(CDirectDrawSurface *pSurface, 
								LPRECT lpRect, DWORD dwTrans)
{
	// BltFast ausfhren
	return lpSurface->BltFast(0, 0, pSurface->lpSurface, lpRect, dwTrans);
}

int CDirectDrawSurface::BltFast(DWORD dwx, DWORD dwy, 
								CDirectDrawSurface *pSurface, 
								DWORD dwTrans)
{
	// BltFast ausfhren
	return lpSurface->BltFast(dwx, dwy, pSurface->lpSurface, 
		NULL, dwTrans);
}

int CDirectDrawSurface::BltFast(CDirectDrawSurface *pSurface, DWORD dwTrans)
{
	// BltFast ausfhren
	return lpSurface->BltFast(0, 0, pSurface->lpSurface, NULL, dwTrans);
}

int CDirectDrawSurface::Restore()
{
	// Surface restaurieren
	return lpSurface->Restore();
}

HBITMAP CDirectDrawSurface::Restore(DWORD dwWidth, DWORD dwHeight,
									LPCSTR pFilename, LPCSTR pResName,
									HINSTANCE Instance, bool bDestroyBMP)
{
	// Surface restaurieren
	if (SUCCEEDED(lpSurface->Restore()))
		// und nun Inhalt des Surfaces restaurieren
		return CopyBitmap(dwWidth, dwHeight, pFilename, 
					pResName, Instance, bDestroyBMP);

	// eben ein Fehler aufgetreten
	return DXDLL_OK;
}

int CDirectDrawSurface::Restore(DWORD dwWidth, DWORD dwHeight,
								HBITMAP hbm)
{
	// Surface restaurieren
	if (SUCCEEDED(lpSurface->Restore()))
		// und nun Inhalt des Surfaces restaurieren
		return CopyBitmap(dwWidth, dwHeight, hbm); 

	// eben ein Fehler aufgetreten
	return DXDLL_INTERNALERROR;
}

int CDirectDrawSurface::IsLost()
{
	// und Funktion ausfhren
	return lpSurface->IsLost();
}

int CDirectDrawSurface::SetColorKey(DWORD dwLowValue, DWORD dwHighValue,
									DWORD dwFlags)
{
	DDCOLORKEY ddcol;

	// Struktur mit Daten fllen
	ddcol.dwColorSpaceLowValue = dwLowValue;
	ddcol.dwColorSpaceHighValue = dwHighValue;

	// und Funktion ausfhren
	if (FAILED(lpSurface->SetColorKey(dwFlags, &ddcol)))
		return Fail(pDirectDraw->hWindow, DXDLL_MSGERROR_SURFACECOLORKEYSET);

	if (pDDFadeSurface)
		if (FAILED(pDDFadeSurface->lpSurface->SetColorKey(dwFlags, &ddcol)))
			return Fail(pDirectDraw->hWindow, 
				DXDLL_MSGERROR_SURFACEFADECOLORKEYSET);

	return DXDLL_OK;
}

int CDirectDrawSurface::GetColorKey(DWORD *dwLowValue, DWORD *dwHighValue,
									DWORD dwFlags)
{
	DDCOLORKEY ddcol;
	HRESULT hres;

	// als erstes Colorkeys holen
	hres = lpSurface->GetColorKey(dwFlags, &ddcol);
	// lief alles ok?
	if (SUCCEEDED(hres))
	{
		// jetzt Rckgabeparameter belegen
		*dwLowValue = ddcol.dwColorSpaceLowValue;
		*dwHighValue = ddcol.dwColorSpaceHighValue;
	}

	// und Fehler zurckliefern
	return hres;
}

int CDirectDrawSurface::Blt(DWORD dwx, DWORD dwy, CDirectDrawSurface *pDDSurface, 
							LPRECT lpSrcRect, DWORD dwFlags)
{
	RECT DestRect;

	// Zielrechteck berechnen
	DestRect.left = dwx;
	DestRect.top = dwy;
	DestRect.bottom = dwy+ lpSrcRect->bottom- 
		lpSrcRect->top;
	DestRect.right = dwx+ lpSrcRect->right- 
		lpSrcRect->left;

	// und anzeigen
	return lpSurface->Blt(&DestRect, pDDSurface->lpSurface, 
		lpSrcRect, dwFlags, NULL);
}

int CDirectDrawSurface::Blt(CDirectDrawSurface *pDDSurface, 
							LPRECT lpSrcRect, DWORD dwFlags)
{
	RECT DestRect;

	// Zielrechteck berechnen
	DestRect.left = 0;
	DestRect.top = 0;
	DestRect.bottom = lpSrcRect->bottom- 
		lpSrcRect->top;
	DestRect.right = lpSrcRect->right- 
		lpSrcRect->left;

	// und anzeigen
	return lpSurface->Blt(&DestRect, pDDSurface->lpSurface, 
		lpSrcRect, dwFlags, NULL);
}

int CDirectDrawSurface::Blt(CDirectDrawSurface *pDDSurface, DWORD dwFlags)
{
	RECT DestRect;
	RECT SrcRect;

	// Zielrechteck berechnen
	DestRect.left = 0;
	DestRect.top = 0;
	DestRect.bottom = iSurfaceHeight- 1;
	DestRect.right = iSurfaceHeight- 1;
	// Quellrechteck berechnen
	SrcRect.left = 0;
	SrcRect.top = 0;
	SrcRect.bottom = pDDSurface->iSurfaceHeight- 1;
	SrcRect.right = pDDSurface->iSurfaceHeight- 1;

	// und anzeigen
	return lpSurface->Blt(&DestRect, pDDSurface->lpSurface, 
		&SrcRect, dwFlags, NULL);
}

int CDirectDrawSurface::Blt(LPRECT lpDestRect, CDirectDrawSurface *pDDSurface, 
							LPRECT lpSrcRect, DWORD dwFlags)
{
	// und anzeigen
	return lpSurface->Blt(lpDestRect, pDDSurface->lpSurface, 
		lpSrcRect, dwFlags, NULL);
}

int CDirectDrawSurface::BltFade(CDirectDrawSurface *pDDSurface, DWORD dwFlags,
								int iFadeRed, int iFadeGreen, int iFadeBlue)
{
	RECT DestRect;
	RECT SrcRect;

	// Zielrechteck berechnen
	DestRect.left = 0;
	DestRect.top = 0;
	DestRect.bottom = iSurfaceHeight- 1;
	DestRect.right = iSurfaceHeight- 1;
	// Quellrechteck berechnen
	SrcRect.left = 0;
	SrcRect.top = 0;
	SrcRect.bottom = pDDSurface->iSurfaceHeight- 1;
	SrcRect.right = pDDSurface->iSurfaceHeight- 1;

	// und anzeigen
	return lpSurface->Blt(&DestRect, pDDSurface->lpSurface, 
		&SrcRect, dwFlags, NULL);
}

int CDirectDrawSurface::BltFade(CDirectDrawSurface *pDDSurface, 
								LPRECT lpSrcRect, DWORD dwFlags,
								int iFadeRed, int iFadeGreen, int iFadeBlue)
{
	RECT DestRect;

	// Zielrechteck berechnen
	DestRect.left = 0;
	DestRect.top = 0;
	DestRect.bottom = lpSrcRect->bottom- 
		lpSrcRect->top;
	DestRect.right = lpSrcRect->right- 
		lpSrcRect->left;

	// und anzeigen
	return lpSurface->Blt(&DestRect, pDDSurface->lpSurface, 
		lpSrcRect, dwFlags, NULL);
}

int CDirectDrawSurface::BltFade(DWORD dwx, DWORD dwy, 
								CDirectDrawSurface *pDDSurface, 
								LPRECT lpSrcRect, DWORD dwFlags,
								int iFadeRed, int iFadeGreen, int iFadeBlue)
{
	// Fadesurface ermitteln
	CDirectDrawSurface* pDDFade = pDDSurface->pDDFadeSurface;

	// existiert ein Fadesurface?
	if (pDDFade)
	{
		DXDLL_DDSURFACEDESC ddsSrc;
		int ix;
		int iy;
		int iAdressSrc;
		WORD* pSrcSurface;
		int lPitchSrc;
		int iHeight = lpSrcRect->bottom- lpSrcRect->top;
		int iWidth = lpSrcRect->right- lpSrcRect->left;
		WORD wVal;
		int iRed;
		int iGreen;
		int iBlue;
		int ioRed;
		int ioGreen;
		int ioBlue;

		// als erstes Bild temporr kopieren
		pDDFade->Blt(0, 0, pDDSurface, lpSrcRect, 0);

		// luft das sperren der temporren Oberflche ok?
		if (SUCCEEDED(pDDFade->Lock(&ddsSrc, DDLOCK_WAIT | 
									DDLOCK_WRITEONLY, NULL)))
		{
			// ... Surface holen
			pSrcSurface = (WORD*)ddsSrc.lpSurface;
			lPitchSrc = ddsSrc.lPitch/ 2;

			// jetzt ber Zeilen ein Schleife laufen lassen
			for (iy=0; iy<iHeight; iy++)
			{
				// Quellposition errechnen
				iAdressSrc = iy* lPitchSrc;
				// ber jede Zeile eine weitere ber die Spalte
				for (ix=0; ix<iWidth; ix++)
				{
					// als erstes Farbe holen
					wVal = pSrcSurface[iAdressSrc];

					// jetzt Farbanteile ermitteln
					iRed = ioRed = GetRValue(wVal);
					iGreen = ioGreen = GetGValue(wVal);
					iBlue = ioBlue = GetBValue(wVal);
					// ... diese runtersetzen
					iRed-= iFadeRed;
					iGreen-= iFadeGreen;
					iBlue-= iFadeBlue;
					// unter null angekommen?
					if (iRed <= 0)
						iRed = 0;
					if (iGreen <= 0)
						iGreen = 0;
					if (iBlue <= 0)
						iBlue = 0;
					// ber Original angekommen?
					if (iRed >= ioRed)
						iRed = ioRed;
					if (iGreen >= ioGreen)
						iGreen = ioGreen;
					if (iBlue >= ioBlue)
						iBlue = ioBlue;
					// nun neue Farbe daraus ermitteln
					wVal = WORD(RGB(iRed, iGreen, iBlue));

					// und diese zurckschreiben
					pSrcSurface[iAdressSrc++] = wVal;
				}
			}
			// Oberflchen wieder entsperren
			pDDFade->Unlock();

			lpSrcRect->top = 0;
			lpSrcRect->bottom = iHeight;
			lpSrcRect->left = 0;
			lpSrcRect->right = iWidth;

			// und anzeigen
			return Blt(dwx, dwy, pDDFade, lpSrcRect, dwFlags);
		}
	}

	return DXDLL_INTERNALERROR;
}

int CDirectDrawSurface::BltFade(LPRECT lpDestRect,
								CDirectDrawSurface *pDDSurface, 
								LPRECT lpSrcRect, DWORD dwFlags,
								int iFadeRed, int iFadeGreen, int iFadeBlue)
{
	// und anzeigen
	return lpSurface->Blt(lpDestRect, pDDSurface->lpSurface, 
		lpSrcRect, dwFlags, NULL);
}


int CDirectDrawSurface::CreateFadeSurface(int iMaxWidth, int iMaxHeight)
{
	// altes zerstren
	DestroyFadeSurface();
	// ... und neues anlegen
	pDDFadeSurface = new CDirectDrawSurface(pDirectDraw);
	// ... mit Einstellungen belegen
	pDDFadeSurface->SetSurfaceDescData(&ddsdesc);

	// ... und anlegen
	return pDDFadeSurface->CreateOffscreenSurface(iMaxWidth, iMaxHeight);
}

void CDirectDrawSurface::DestroyFadeSurface()
{
	// ist schon eins erzeugt?
	if (pDDFadeSurface)
	{
		// ... dann zerstren
		delete pDDFadeSurface;
		pDDFadeSurface = NULL;
	}
}

int CDirectDrawSurface::SetClipper(CDirectDrawClipper* pClipper)
{
	// ist schon eins erzeugt?
	if (lpSurface && pClipper)
		// ... dann setzen
		return lpSurface->SetClipper(pClipper->lpDDClipper);

	// ... ansonsten immer Fehler
	return DXDLL_INTERNALERROR;
}

int CDirectDrawSurface::AddAttachedSurface(CDirectDrawSurface* pSurface)
{
	// gltige Werte?
	if (lpSurface && pSurface)
		// dann hinzufgen
		return lpSurface->AddAttachedSurface(pSurface->lpSurface);

	// ansonsten raus
	return DXDLL_INTERNALERROR;
}

int CDirectDrawSurface::ClearSurface(DWORD dwColor)
{
	DDBLTFX ddbltfx;

	// FX-Werte lschen und neu angeben
	ZeroMemory(&ddbltfx, sizeof(DDBLTFX));
	ddbltfx.dwSize = sizeof(DDBLTFX);
	ddbltfx.dwFillColor = dwColor;

	// ... jetzt lschen und Fehler zurckliefern
	return lpSurface->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | 
		DDBLT_WAIT, &ddbltfx);
}

