// DirectInput.cpp: Implementierung der Klasse CDirectInput.
//
//////////////////////////////////////////////////////////////////////

#include "DirectInput.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDirectInput::CDirectInput()
{
	// alle Daten resetten
	hInstance = NULL;
	hWindow = NULL;
	lpDI = NULL;
}

CDirectInput::CDirectInput(HINSTANCE hInst, HWND hWnd)
{
	// alle Daten bertragen
	hInstance = hInst;
	hWindow = hWnd;
	lpDI = NULL;

	// DirectInput-Objekt anlegen
	DirectInputCreate();
}

CDirectInput::~CDirectInput()
{
	// noch alles lschen
	DirectInputDestroy();
}

int CDirectInput::DirectInputCreate()
{
	HRESULT hres = 0;
	LPDIRECTINPUT lpDITemp;

	// altes vorher zerstren
	DirectInputDestroy();

	// DirectInput-Objekt erzeugen
	if (FAILED(::DirectInputCreate(hInstance, DIRECTINPUT_VERSION,
			&lpDITemp, NULL)))
		// bei Fehler Fehlermeldung anzeigen
		return Fail(hWindow, DXDLL_MSGERROR_DINPUTCREATE);

	// DirectDraw-Objekt erzeugen
	if (FAILED(lpDITemp->QueryInterface(IID_IDirectInput2, (LPVOID*)&lpDI)))
		// ebenfalls raus, falls Fehler
		hres = Fail(hWindow, DXDLL_MSGERROR_DINPUT2CREATE);
	lpDITemp->Release();

	return hres;
}

int CDirectInput::DirectInputDestroy()
{
	// existiert DirectInput-Objekt?
	if (lpDI)
	{
		// ... dann lschen
		lpDI->Release();
		lpDI = NULL;
	}
}


int CDirectInput::RunControlPanel()
{
	// ControlPanel von Windows anzeigen
	return lpDI->RunControlPanel(hWindow, NULL);
}

int CDirectInput::GetDeviceStatus(GUID *lpGUID)
{
	// Status des Gertes abfragen
	return lpDI->GetDeviceStatus((REFGUID)lpGUID);
}

