// DirectSetup.cpp: Implementierung der Klasse CDirectSetup.
//
//////////////////////////////////////////////////////////////////////

#include "DirectSetup.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDirectSetup::CDirectSetup()
{
	// alle Variablen resetten
	hWindow = NULL;
}

CDirectSetup::CDirectSetup(HWND hWnd)
{
	// alle Variablen bertragen
	hWindow = hWnd;
}

CDirectSetup::~CDirectSetup()
{
}

int CDirectSetup::DirectXSetup(HWND hWnd, LPTSTR lpszRootPath, DWORD dwFlags)
{
	// und jetzt die Routine aufrufen
	return ::DirectXSetup(hWnd, lpszRootPath, dwFlags);
}

int CDirectSetup::DirectXSetup(LPTSTR lpszRootPath, DWORD dwFlags)
{
	if (hWindow)
		// und jetzt die Routine aufrufen
		return ::DirectXSetup(hWindow, lpszRootPath, dwFlags);

	// ... ansonsten Fehler
	return DXDLL_INTERNALERROR;
}

int CDirectSetup::DirectXSetup(DWORD dwFlags)
{
	if (hWindow)
		// und jetzt die Routine aufrufen
		return ::DirectXSetup(hWindow, NULL, dwFlags);

	// ... ansonsten Fehler
	return DXDLL_INTERNALERROR;
}

int CDirectSetup::DirectXSetupGetVersion(DWORD* pdwVersion, 
										 DWORD* pdwRevision)
{
	// ... und aufrufen
	return ::DirectXSetupGetVersion(pdwVersion, pdwRevision);
}

int CDirectSetup::DirectXSetupSetCallback(DSETUP_CALLBACK Callback)
{
	// ... und aufrufen
	return ::DirectXSetupSetCallback(Callback);
}

void CDirectSetup::SetAppInfo(LPDIRECTXREGISTERAPP lpRegApp)
{
	// ... und nun den gesamten Block kopieren
	memcpy(&RegisterApp, lpRegApp, sizeof(DIRECTXREGISTERAPP));
	// ... jetzt noch Gre eintragen
	RegisterApp.dwSize = sizeof(DIRECTXREGISTERAPP);
}

void CDirectSetup::SetAppInfo(LPSTR lpszAppName, LPGUID lpGUID,
							  LPSTR lpszFilename, LPSTR lpszCmdLine,
							  LPSTR lpszPath, LPSTR lpszCurrPath)
{
	// erstmal alles andere lschen
	ZeroMemory(&RegisterApp, sizeof(DIRECTXREGISTERAPP));

	// ... jetzt noch den Rest eintragen
	RegisterApp.dwSize = sizeof(DIRECTXREGISTERAPP);
	RegisterApp.dwFlags = 0;

	// alle Strings bertragen
	strcpy(RegisterApp.lpszFilename, lpszFilename);
	strcpy(RegisterApp.lpszCommandLine, lpszCmdLine);
	strcpy(RegisterApp.lpszPath, lpszPath);
	strcpy(RegisterApp.lpszCurrentDirectory, lpszCurrPath);

	// als letztes den GUID kopieren
	RegisterApp.lpGUID = lpGUID;
}

int CDirectSetup::DirectXRegisterApplication(HWND hWnd)
{
	// und Registrierung auslsen
	return ::DirectXRegisterApplication(hWnd, &RegisterApp);
}

int CDirectSetup::DirectXRegisterApplication()
{
	// und Registrierung auslsen
	return ::DirectXRegisterApplication(hWindow, &RegisterApp);
}

int CDirectSetup::DirectXUnRegisterApplication(HWND hWnd, LPGUID lpGUID)
{
	// und Lschung einleiten
	return ::DirectXUnRegisterApplication(hWnd, lpGUID);
}

int CDirectSetup::DirectXUnRegisterApplication(LPGUID lpGUID)
{
	// und Lschung einleiten
	return ::DirectXUnRegisterApplication(hWindow, lpGUID);
}

