// DirectSetup.h: Schnittstelle fr die Klasse CDirectSetup.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIRECTSETUP_H__436E46A0_DA13_11D2_AD5A_C618DF7CB84B__INCLUDED_)
#define AFX_DIRECTSETUP_H__436E46A0_DA13_11D2_AD5A_C618DF7CB84B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "DXDefines.h"
#include "dsetup.h"

// ----------------------------------------------------
// richtige komplette Definionen der einzelnen Klassen
// ----------------------------------------------------
class CDirectSetup  
{
public:
	CDirectSetup();
	CDirectSetup(HWND hWnd);
	virtual ~CDirectSetup();

	// ruft die interne DX-Setup-Routine auf
	int DirectXSetup(HWND hWnd, LPTSTR lpszRootPath, DWORD dwFlags);
	// ruft die interne DX-Setup-Routine auf
	int DirectXSetup(LPTSTR lpszRootPath, DWORD dwFlags);
	// ruft die interne DX-Setup-Routine auf
	int DirectXSetup(DWORD dwFlags);

	// holt sich die aktuelle DirectX-Version
	int DirectXSetupGetVersion(DWORD* pdwVersion, DWORD* pdwRevision);

	// setzt eine Rckruffunktion fr den Setup-Vorgang
	int DirectXSetupSetCallback(DSETUP_CALLBACK Callback);

	// setzt Informationen zur Applikation (fr DX-Registrierung)
	void SetAppInfo(LPDIRECTXREGISTERAPP lpRegApp);
	// setzt Informationen zur Applikation (fr DX-Registrierung)
	void SetAppInfo(LPSTR lpszAppName, LPGUID lpGUID, LPSTR lpszFilename, 
		LPSTR lpszCmdLine, LPSTR lpszPath, LPSTR lpszCurrPath);

	// registriert die Applikation mit angegebenen Werten in Registry
	int DirectXRegisterApplication(HWND hWnd);
	// registriert die Applikation mit angegebenen Werten in Registry
	int DirectXRegisterApplication();

	// lscht Registrierung einer Applikation wieder
	int DirectXUnRegisterApplication(HWND hWnd, LPGUID lpGUID);
	// lscht Registrierung einer Applikation wieder
	int DirectXUnRegisterApplication(LPGUID lpGUID);

private:
	// Fenster, da zu Anwendung gehrt
	HWND hWindow;
	// Informationen der Applikation
	DIRECTXREGISTERAPP RegisterApp;
};

#endif // !defined(AFX_DIRECTSETUP_H__436E46A0_DA13_11D2_AD5A_C618DF7CB84B__INCLUDED_)
