// DirectSound.h: Schnittstelle fr alle Klassen von DirectSound.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIRECTSOUND_H__57C7A900_8182_11D2_B0DF_40584EC1BE27__INCLUDED_)
#define AFX_DIRECTSOUND_H__57C7A900_8182_11D2_B0DF_40584EC1BE27__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// alle mglichen Defines
#include "DXDefines.h"
// alle mglichen Tools
#include "Tools.h"
// DirectSound-Verwaltung
#include "dsound.h"


// -------------------------------------------
// Forwarddeklarationen der einzelnen Klassen
// -------------------------------------------
class CDirectSound;
class CDirectSoundBuffer;


// ----------------------------------------------------
// richtige komplette Definionen der einzelnen Klassen
// ----------------------------------------------------
class __declspec(dllexport) CDirectSound  
{
public:
	CDirectSound();
	CDirectSound(HWND hMainWindow);
	CDirectSound(HWND hMainWindow, DWORD dwDSFlags, DWORD dwDSBFlags);
	CDirectSound(HWND hMainWindow, GUID* lpGUID, DWORD dwDSFlags, 
		DWORD dwDSBFlags);
	virtual ~CDirectSound();

	// erzeugt primren DS-Interface
	int DirectSoundCreate();
	// erzeugt DS-Interface mit angegebenen GUID
	int DirectSoundCreate(GUID* lpGUID);
	// setzt Kooperationsebene mit anderen Win-Programmen
	int SetCooperativeLevel(DWORD dwFlags);
	// zerstrt komplettes DS-Objekt und gibt Interfaces frei
	void DirectSoundDestroy();

	// setzt Handle des Hauptfensters der Anwendung
	HWND SetMainWindow(HWND hMainWindow);

	// setzt den primren Buffer
	CDirectSoundBuffer* SetPrimarySoundBuffer(CDirectSoundBuffer* pDSB);
	// ermittelt Pointer auf Klasse mit primren Buffer
	CDirectSoundBuffer* GetPrimarySoundBuffer();

	// Pointer auf DS-Interface
	DXDLL_LPDIRECTSOUND lpDS;
	// Pointer auf Klasse mit primren Buffer
	CDirectSoundBuffer* pDSBPrimary;
	// Handle auf Hauptfenster der Anwendung
	HWND hWindow;
};

class __declspec(dllexport) CDirectSoundBuffer
{
public:
	CDirectSoundBuffer();
	CDirectSoundBuffer(CDirectSound* pDS);
	virtual ~CDirectSoundBuffer();

	// erzeugt einen primren Soundbuffer mit definierter Gre
	int CreatePrimaryDirectSoundBuffer(DWORD dwFlags);
	// erzeugt einen Soundbuffer mit definierter Gre
	int CreateDirectSoundBuffer(DWORD dwSize);
	// zerstrt Buffer im RAM und gibt Interface frei
	void DirectSoundBufferDestroy();

	void SetBufferDescData(DWORD dwFlags, LPWAVEFORMATEX lpFormat);
	void SetBufferDescData(DSBUFFERDESC* lpBufDesc);

	// ldt eine WAV-Datei aus Resourcen der aktuellen EXE
	int LoadWAV(LPCTSTR lpName, LPCSTR lpWAVSection, DWORD dwFlags);
	// ldt eine WAV-Datei aus Resourcen eines beliebigen Moduls
	int LoadWAV(HMODULE hModule, LPCTSTR lpName, LPCSTR lpWAVSection, 
		DWORD dwFlags);

	// stoppt Soundausgabe
	int Stop();
	// beginnt Buffer mit angegebenen Flags zu spielen
	int Play(DWORD dwFlags);

	// Buffereinstellungen
	DSBUFFERDESC dsbdesc;
	// DirectSoundBuffer-Objekt
	DXDLL_LPDIRECTSOUNDBUFFER lpDSB;
	// ... und das DirectSound-Objekt
	CDirectSound* pDirectSound;
};

#endif // !defined(AFX_DIRECTSOUND_H__57C7A900_8182_11D2_B0DF_40584EC1BE27__INCLUDED_)
